#include <variable.h>
#include <object.h>

OBJECT object;
std::vector<OBJECT> objects;
void clear();
void input_data(){

    //input data
    if(mode=="line"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //write data
            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="linestrip"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //morph into linestrip
            object.type="linestrip";
            object.control.push_back({mx,my,mz});
            click=2;
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
        if(int_key==16777220){//key enter
            object.end.x=object.control.back().x; //save including the last control point
            object.end.y=object.control.back().y;
            object.end.z=object.control.back().z;
            objects.push_back(object);
            clear();
        }
    }

    if(mode=="rectangular"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="rectangular";
            object.start.x=mx; //lower left corner
            object.start.y=my;
            object.start.z=mz;
            object.control.push_back({mx,my,mz}); //upper left corner
            object.end.x=mx; //upper right corner
            object.end.y=my;
            object.end.z=mz;
            object.control.push_back({mx,my,mz}); //lower right corner
            click=2;
        }
        if(click==2){ //preview
            //lower left is unchanged.
            object.control.front().y=my; //upper left corner
            object.end.x=mx; //upper right corner
            object.end.y=my;
            object.end.z=mz;
            object.control.back().x=mx; //lower right corner
        }
        if(click==3){ //write data
            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="circle"){
        if(click==0){
            message = "click centerpoint";
        }
        if(click==1){
            object.type="circle";
            object.center.x=mx;
            object.center.y=my;
            object.center.z=mz;
            click=2;
        }
        if(click==2){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //write data
            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="ellipse"){
        if(click==0){
            message = "click centerpoint";
        }
        if(click==1){
            object.type="line";
            object.center.x=mx;
            object.center.y=my;
            object.center.z=mz;
            click=2;
        }


        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="arc"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview as line
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //morph into arc
            object.type="arc";
            object.control.push_back({object.end.x,object.end.y,object.end.z});
            click=4;
        }
        if(click==4){ //preview arc endpoint
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==5){ //write arc
            objects.push_back(object);
            clear();
        }

        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="spline"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview as line
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //morph into spline
            object.type="spline";
            object.control.push_back({object.end.x,object.end.y,object.end.z});
            click=4;
        }
        if(click==4){ //preview spline endpoint
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }

        if(click>4){ //add new controlpoint
            click=3;
        }

        if(int_key==16777216){//key escape, clean preview data
            clear();
        }

        if(int_key==16777220){//key enter
            if(object.control.size()>1){
                object.end.x=object.control.back().x; //finish spline to last clicked point
                object.end.y=object.control.back().y;
                object.end.z=object.control.back().z;
            }

            objects.push_back(object); //add spline to program data, clean preview data
            clear();
        }
    }
}

void clear(){
    object.type="";
    object.start.x=0;
    object.start.y=0;
    object.start.z=0;
    object.end.x=0;
    object.end.y=0;
    object.end.z=0;
    object.control.clear();
    click=0;
    int_key=-1; //reset key
}































