#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QLineEdit>
#include <QSpinBox>
#include <QComboBox>
#include <QTreeWidget>
#include <QTreeWidgetItem>
#include <QStringList>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

    void keyPressEvent(QKeyEvent *event);
    void keyReleaseEvent(QKeyEvent *event);

protected:

    void timerEvent(QTimerEvent *);

private slots:

    void on_toolButton_line_pressed();

    void on_toolButton_open_pressed();

    void on_toolButton_spline_pressed();

    void on_toolButton_debug_pressed();

    void on_toolButton_arc_pressed();

    void on_toolButton_circle_pressed();

    void on_toolButton_rectangular_pressed();

    void on_toolButton_linestrip_pressed();

    void on_toolButton_ellipse_pressed();

private:
    Ui::MainWindow *ui;
    int timerId;
};

#endif // MAINWINDOW_H
